program tsp
    implicit none
    integer, parameter :: n = 7
    double precision :: dist(n, n)
    double precision, dimension(n) :: x, y
    integer :: i, j, start, current, min_index
    double precision :: min_dist, total_dist
    logical, dimension(n) :: visited

    ! Inserisci qui le coordinate dei tuoi punti (x, y)
    x = [0.0, 2.0, 3.0, 5.0, 7.0, 1.0, 4.0]
    y = [0.0, 3.0, 5.0, 1.0, 3.0, 2.0, 4.0]

    ! Calcola la matrice delle distanze
    do i = 1, n
        do j = 1, n
            dist(i, j) = sqrt((x(i) - x(j))**2 + (y(i) - y(j))**2)
        end do
    end do

    ! Inizializzazione
    start = 1           ! indice del punto di partenza
    current = start     ! punto corrente inizialmente uguale al punto di partenza
    total_dist = 0.0
    visited = .false.   ! inizializza tutti i punti come non visitati
    visited(start) = .true.  ! segna il punto di partenza come visitato

    ! Trova il percorso minimizzando la distanza totale
    do
        min_dist = 1.0e30  ! Imposta una distanza molto alta
        min_index = -1     ! Inizializza l'indice minimo

        do i = 1, n
            if (.not. visited(i) .and. dist(current, i) < min_dist) then
                min_dist = dist(current, i)
                min_index = i
            end if
        end do

        if (min_index == -1) exit  ! Se non ci sono più punti visitabili, esci dal ciclo

        ! Aggiorna la posizione corrente, la distanza totale e il vettore dei visitati
        visited(min_index) = .true.
        total_dist = total_dist + min_dist
        current = min_index

        print *, 'Travelling from point ', current, ' to point ', min_index

        ! Se il punto corrente è il punto finale, termina il ciclo
        if (current == n) exit
    end do

    print *, 'Total distance travelled: ', total_dist

end program tsp
